const std = @import("std");

pub fn djb2(comptime Int: type, bytes: []const u8) Int {
    var hash = @as(Int, @intCast(5381));

    for (bytes) |byte| {
        hash = ((hash << 5) +% hash) +% byte;
    }

    return hash;
}

pub fn jenkins(comptime Int: type, bytes: []const u8) Int {
    var hash = @as(Int, 0);

    for (bytes) |byte| {
        hash +%= byte;
        hash +%= (hash << 10);
        hash ^= (hash >> 6);
    }

    hash +%= (hash << 3);
    hash ^= (hash >> 11);
    hash +%= (hash << 15);

    return hash;
}
